unit LibShowUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ImgList, cad, StdCtrls, Buttons, ExtCtrls, Spin,
  Menus;

type
  TLibShowFrm = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    LibImageList: TImageList;
    PageControl: TPageControl;
    PopupMenu1: TPopupMenu;
    CloseLib: TMenuItem;
    procedure FormDestroy(Sender: TObject);
    procedure CloseLibClick(Sender: TObject);
   // procedure TabSheetShow(Sender: TObject);
  private
    { Private declarations }
     ATabSheet:TTabSheet;
     AListView:TListView;
      procedure TabSheetShow(Sender: TObject);

  public
    mLibManager:TLibManager;
    mListView:TListView;
    LibManagers:Array of TLibManager;
    procedure DrawListView(LibFileName:string);
    procedure LoadLib(LibFileName:String);
    procedure RemoveLibManager(id:integer);
  end;

var
  LibShowFrm: TLibShowFrm;

implementation

{$R *.dfm}

{ TLibShowFrm }

procedure TLibShowFrm.DrawListView(LibFileName:string);
begin
end;

procedure TLibShowFrm.FormDestroy(Sender: TObject);
var
 i:integer;
begin
  for i:= 0 to High(LibManagers) do
    LibManagers[i].Free;
end;

procedure TLibShowFrm.LoadLib(LibFileName: String);
var
 i:integer;
 ABitmap:TBitmap;
 AListItem: TListItem;
 AlibImageList:TImageList;
 mCaption:string;

begin
  if IsTCADLibFile(LibFileName) then
  begin

    for i:=0 to High(LibManagers) do
    begin
      if Pos(LibManagers[High(LibManagers)].LibFileName,
            LibFileName ) > 0 then
             begin
              ShowMessage('This Lib: '+ LibFileName +' has been opened!');
              exit;
             end;

    end;


   SetLength(LibManagers,High(LibManagers)+2);
   LibManagers[High(LibManagers)]:=TLibManager.Create;
   LibManagers[High(LibManagers)].LoadFromFile(LibFileName);
   mLibManager:=   LibManagers[High(LibManagers)];

   ATabSheet:=TTabSheet.Create( PageControl);
   ATabSheet.Parent:= PageControl;
   ATabSheet.PageControl:=  PageControl;
   ATabSheet.Caption:=copy(LibManagers[High(LibManagers)].LibFileName,0,
       pos('.',LibManagers[High(LibManagers)].LibFileName)-1);
   ATabSheet.OnShow:=     TabSheetShow;
   PageControl.ActivePage:=ATabSheet;




  AlibImageList:=TImageList.Create(ATabSheet);
  AlibImageList.Height := 32;
  AlibImageList.Width  := 32;
  ABitmap:=TBitmap.Create;
  For i:=0 to mLibManager.cmbShapesCount -1  do
   begin
    mCaption:=   mLibManager.GetCmbShapesNameByID(i);
    mLibManager.GetCmbShapeimage(mCaption, AlibImageList.Width,ABitmap,ClGray);
     AlibImageList.Add(ABitmap,nil);

   end;
  ABitmap.Free;

   AListView:=TListView.Create(ATabSheet);
   AListView.Parent:=ATabSheet;
   AListView.Align:=alClient;
   AListView.ViewStyle:=  vsIcon;
   AListView.IconOptions.AutoArrange:=true;
   AListView.LargeImages:= AlibImageList;
   AListView.Color:=ClGray;
   AListView.DragMode :=dmAutomatic;
//  AListView.Clear  ;
  For i:=0 to mLibManager.cmbShapesCount -1  do
    begin
    AListItem:=AListView.Items.Add;
    mCaption:=  mLibManager.GetCmbShapesNameByID(i);
    AListItem.Caption:=mCaption;
    AListItem.ImageIndex:=i;
   end;


    mListView:=AListView;

  end;

end;

procedure TLibShowFrm.TabSheetShow(Sender: TObject);
var
  i:integer;
begin
if  (Sender As TTabSheet).ComponentCount = 2 then
begin
  for i:=0 to High(LibManagers) do
   if Pos((Sender As TTabSheet).Caption, LibManagers[i].LibFileName)>0 then
   begin
     mLibManager :=  LibManagers[i];
     mListView:=(Sender As TTabSheet).Components[1] as TListView;
    end;
end;
end;

procedure TLibShowFrm.RemoveLibManager(id:integer);
var
  i:integer;
begin
LibManagers[Id].Free;
    for i:=id to High(LibManagers)-1 do
    LibManagers[i]:= LibManagers[i+1];

   // LibManagers[High(LibManagers)].Free;
    SetLength(LibManagers,High(LibManagers))
end;

procedure TLibShowFrm.CloseLibClick(Sender: TObject);
var
 id,i:integer;
begin
 id:=-1;
  for i:=0 to High(LibManagers) do
   if pos(PageControl.ActivePage.Caption, LibManagers[i].LibFileName) >0 then
     id:=i;


 if Id > -1 then    RemoveLibManager(id);
 if   PageControl.ActivePage <> nil then  PageControl.ActivePage.Free;
end;

end.
