unit SetupUnit;

interface

uses
  Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, cad, Buttons, ExtDlgs, ExtCtrls;

type
  TSetupFrm = class(TForm)
    GroupBox2: TGroupBox;
    Label14: TLabel;
    Label15: TLabel;
    SpinEdit5: TSpinEdit;
    SpinEdit6: TSpinEdit;
    CheckBox3: TCheckBox;
    GroupBox1: TGroupBox;
    Label13: TLabel;
    CheckBox2: TCheckBox;
    SpinEdit7: TSpinEdit;
    OpenPictureDialog1: TOpenPictureDialog;
    GroupBox3: TGroupBox;
    ComboBox1: TComboBox;
    Label11: TLabel;
    Label12: TLabel;
    SpinEdit3: TSpinEdit;
    SpinEdit4: TSpinEdit;
    Label1: TLabel;
    GroupBox4: TGroupBox;
    BitBtn2: TBitBtn;
    BitBtn1: TBitBtn;
    ComboBox2: TComboBox;
    Label3: TLabel;
    BitBtn3: TBitBtn;
    Panel1: TPanel;
    Image1: TImage;
    GroupBox5: TGroupBox;
    SetRatioBtn: TButton;
    ratioEdit: TSpinEdit;
    Label4: TLabel;
    Label5: TLabel;
    unitCmb: TComboBox;
    Label6: TLabel;
    procedure CheckBox2Click(Sender: TObject);
    procedure SpinEdit7Change(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure SpinEdit5Change(Sender: TObject);
    procedure SpinEdit6Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure SpinEdit4Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure unitCmbChange(Sender: TObject);
    procedure SetRatioBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SetupFrm: TSetupFrm;

implementation

uses MainUnit;

{$R *.dfm}

procedure TSetupFrm.CheckBox2Click(Sender: TObject);
begin
  MainFrm.MyCAD1.Snap := CheckBox2.Checked;
  SpinEdit7.Enabled := CheckBox2.Checked;
end;

procedure TSetupFrm.SpinEdit7Change(Sender: TObject);
begin
  with MainFrm do
    if (SpinEdit7.Value > Mycad1.Gridoperation.GridWidth) or
      (SpinEdit7.Value > Mycad1.Gridoperation.GridHeight)
      then
    begin
      ShowMessage('Pixels is too many!');
      SpinEdit7.Value := 3;
    end
    else
      MyCAD1.SnapPixels := SpinEdit7.Value;
end;

procedure TSetupFrm.CheckBox3Click(Sender: TObject);
begin
  MainFrm.MyCAD1.Gridoperation.GridShow := CheckBox3.Checked;
end;

procedure TSetupFrm.SpinEdit5Change(Sender: TObject);
begin
  MainFrm.MyCAD1.Gridoperation.GridWidth := SpinEdit5.Value;
end;

procedure TSetupFrm.SpinEdit6Change(Sender: TObject);
begin
  MainFrm.MyCAD1.Gridoperation.GridHeight := SpinEdit6.Value;
end;

procedure TSetupFrm.ComboBox1Change(Sender: TObject);
begin
  with MainFrm do
  begin
    case ComboBox1.ItemIndex of
      0: Mycad1.PageStyle := A3;
      1: Mycad1.PageStyle := A4;
      2: Mycad1.PageStyle := A5;
      3: Mycad1.PageStyle := B3;
      4: Mycad1.PageStyle := B4;
      5: Mycad1.PageStyle := B5;
    end;
    if ComboBox1.ItemIndex < 6 then
    begin
      SpinEdit3.value := MyCAD1.Width;
      SpinEdit4.value := MyCAD1.Height;
    end;
  end;
end;

procedure TSetupFrm.SpinEdit3Change(Sender: TObject);
begin
  MainFrm.MyCAD1.width := SpinEdit3.Value;
end;

procedure TSetupFrm.SpinEdit4Change(Sender: TObject);
begin
  MainFrm.MyCAD1.Height := SpinEdit4.Value;

end;

procedure TSetupFrm.FormShow(Sender: TObject);
begin
  with MainFrm do
  begin
    SpinEdit3.Value := Mycad1.Width;
    SpinEdit4.Value := Mycad1.Height;

    SpinEdit5.Value := round(Mycad1.Gridoperation.GridWidth);
    SpinEdit6.Value := round(Mycad1.Gridoperation.GridHeight);
  end;
end;

procedure TSetupFrm.BitBtn1Click(Sender: TObject);

var
  mybitmap: TBitmap;
begin
  if OpenPictureDialog1.Execute then
  begin
    myBitmap := TBitmap.Create;

    mybitmap.LoadFromFile(OpenPictureDialog1.FileName);
    MainFrm.MyCAD1.BkBitmap:=MyBitmap;
    Image1.Picture.LoadFromFile(openPictureDialog1.FileName);

    MyBitmap.Free;

  end;
end;

procedure TSetupFrm.BitBtn2Click(Sender: TObject);
begin
  MainFrm.MyCAD1.BkBitmap:=nil;
end;

procedure TSetupFrm.ComboBox2Change(Sender: TObject);
begin
  with MainFrm do
    case Combobox2.itemindex of
      0: Mycad1.BkBitmapMode := LeftTop;
      1: Mycad1.BkBitmapMode := Center;
      2: Mycad1.BkBitmapMode := Tiled;
      3: Mycad1.BkBitmapMode := Stretch;
    end;
end;

procedure TSetupFrm.Image1Click(Sender: TObject);
begin
  BitBtn1Click(Sender);
end;

procedure TSetupFrm.unitCmbChange(Sender: TObject);
begin
case  unitCmb.ItemIndex +1 of
 1:
 MainFrm.MyCAD1.TheUNIT:= inch;
 2:
 MainFrm.MyCAD1.TheUNIT:= mm;
 3:
 MainFrm.MyCAD1.TheUNIT:= pixel;
end;

end;

procedure TSetupFrm.SetRatioBtnClick(Sender: TObject);
begin
 MainFrm.MyCAD1.Ratio:=   ratioEdit.Value/100;
end;

end.
